Subject: Re: [PATCH] Fix routing tables with id > 255 for legacy software

From: Patrick McHardy <[email-masked]>
Date: Tue, 03 Jun 2008 15:10:13 +0200

Krzysztof Oledzki wrote:
> On Tue, 3 Jun 2008, Patrick McHardy wrote:
> 
>> Well, if people already use table 253, I guess they might care.
> 
> Not really as if pople use a FRA_TABLE aware application they should not 
> notice any difference.

In that case not of course.

>> I'm not convinced this is any better than overflowing.
> 
> But if they use FRA_TABLE unaware application than overflowing means 
> mismatching all:
>  - N*256 table as RT_TABLE_UNSPEC
>  - N*256+253 tables as RT_TABLE_DEFAULT
>  - N*256+254 tables as RT_TABLE_MAIN
>  - N*256+255 tables as RT_TABLE_LOCAL
> 
> And as I just find out, when it happens is quite unexpected and can 
> really hurt. :(
> 
>> And I still don't see any other way to handle this properly.
> 
> Exactly. So that's why I came with above solution, similar to AS_TRANSIT 
> idea used in BGP to handle 16bit -> 32bit ASN transformation.

I think the proper solution is what I wrote in the changelog
entry: fix userspace applications when using extended table
IDs.

Your patch makes it more predictable, so I'm not completely
opposed, but still its just a workaround.